Index: /branches/multichoice/gui/scripts/mapviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/mapviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/mapviewer.tcl	(revision 6371)
@@ -36,4 +36,5 @@
     inherit Rappture::VisViewer
 
+    itk_option define -map map Map ""
     itk_option define -plotforeground plotForeground Foreground ""
     itk_option define -plotbackground plotBackground Background ""
@@ -52,10 +53,19 @@
     public method add {dataobj {settings ""}}
     public method camera {option args}
-    public method delete {args}
+    public method clear {args}
+    public method delete {args} { eval hide $args }
     public method disconnect {}
     public method download {option args}
     public method get {args}
+    public method hide {args}
     public method isconnected {}
     public method parameters {title args} { # do nothing }
+    public method placard {option args}
+    public method refresh {} {
+        Rebuild
+        # Temporary hack to fix one frame delay in update
+        SendCmd "imgflush"
+        SendCmd "renderer render"
+    }
     public method scale {args}
     public method select {option {args ""}}
@@ -103,5 +113,5 @@
     private method GetImage { args }
     private method GetNormalizedMouse { x y }
-    private method GoToViewpoint { dataobj viewpoint }
+    private method GoToViewpoint { dataobj viewpoint {duration 2.0} }
     private method InitSettings { args  }
     private method MapIsGeocentric {}
@@ -689,16 +699,15 @@
 
 # ----------------------------------------------------------------------
-# USAGE: delete ?<dataobj1> <dataobj2> ...?
-#
-# Clients use this to delete a dataobj from the plot.  If no dataobjs
-# are specified, then all dataobjs are deleted.  No data objects are
-# deleted.  They are only removed from the display list.
-# ----------------------------------------------------------------------
-itcl::body Rappture::MapViewer::delete {args} {
+# USAGE: hide ?<dataobj1> <dataobj2> ...?
+#
+# Clients use this to hide a dataobj from the plot.  If no dataobjs are
+# specified, then all dataobjs are hidden.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapViewer::hide {args} {
     DebugTrace "Enter"
     if { [llength $args] == 0} {
         set args $_dlist
     }
-    # Delete all specified dataobjs
+    # Mark all specified dataobjs as hidden
     set changed 0
     foreach dataobj $args {
@@ -715,4 +724,62 @@
         }
         array unset _obj2ovride $dataobj-*
+        set changed 1
+    }
+    # If anything changed, then rebuild the plot
+    if { $changed } {
+        $_dispatcher event -idle !rebuild
+    }
+}
+
+# ----------------------------------------------------------------------
+# USAGE: clear ?<dataobj1> <dataobj2> ...?
+#
+# Clients use this to permanently clear a dataobj from the plot and the
+# render server.  If no dataobjs are specified, then all dataobjs are 
+# cleared.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapViewer::clear {args} {
+    DebugTrace "Enter"
+    if { [llength $args] == 0} {
+        set args [concat $_dlist $_hidden]
+    }
+    # Delete all specified dataobjs
+    set changed 0
+    foreach dataobj $args {
+        set found 0
+        set dpos [lsearch -exact $_dlist $dataobj]
+        if { $dpos >= 0 } {
+            set found 1
+        }
+        set hpos [lsearch -exact $_hidden $dataobj]
+        if { $hpos >= 0 } {
+            set found 1
+        }
+        if { !$found } {
+            continue
+        }
+        foreach tag [array names _layers -glob $dataobj-*] {
+            SendCmd "map layer delete $tag"
+        }
+        if { [info commands $dataobj] == $dataobj } {
+            # Remove the layers from the client and server.
+            foreach layer [$dataobj layers] {
+                if { ![$dataobj layer $layer shared] } {
+                    # Remove shared layer if no other objects have it?
+                }
+            }
+        }
+        if { $dpos >= 0 } {
+            # Remove it from the dataobj list.
+            set _dlist [lreplace $_dlist $dpos $dpos]
+        }
+        if { $hpos >= 0 } {
+            # Remove it from the hidden list.
+            set _hidden [lreplace $_hidden $hpos $hpos]
+        }
+        array unset _obj2ovride $dataobj-*
+        array unset _layers $dataobj-*
+        array unset _opacity $dataobj-*
+        array unset _visibility $dataobj-*
         set changed 1
     }
@@ -797,5 +864,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] < 2} {
                 error "wrong # args: should be \"get -image view|legend\""
@@ -989,4 +1056,32 @@
 
 # ----------------------------------------------------------------------
+# USAGE: placard enable <state> <layerName>
+# 
+# Clients use this method to enable/disable display of a feature placard
+# when a feature is clicked/selected.
+# ----------------------------------------------------------------------
+itcl::body Rappture::MapViewer::placard {option args} {
+    switch $option {
+        enable {
+            if {[llength $args] != 2} {
+                error "wrong $ args: should be \"enable <boolean> <layerName>\""
+            }
+            set state [lindex $args 0]
+            set layerName [lindex $args 1]
+            if {![info exists _layers($layerName)]} {
+                error "Unknown layer \"$layerName\""
+            }
+            if {![string is boolean $state]} {
+                error "argument to placard enable must be boolean"
+            }
+            SendCmd "placard enable $state $layerName"
+        }
+        default {
+            error "bad option \"$option\": should be enable"
+        }
+    }
+}
+
+# ----------------------------------------------------------------------
 # USAGE: download coming
 # USAGE: download controls <downloadCommand>
@@ -1378,5 +1473,11 @@
                 set _layers($tag) 1
                 SetLayerStyle $dataobj $layer
-            }
+            } elseif { [$dataobj dirty $layer] } {
+                # Recreate layer
+                # FIXME: retain layer order
+                SendCmd "map layer delete $tag"
+                SetLayerStyle $dataobj $layer
+            }
+            $dataobj dirty $layer 0
             # Don't change visibility of shared/base layers
             if { !$info(shared) } {
@@ -1761,4 +1862,6 @@
                 $_click(y) == $y} {
                 SendCmd "map box clear"
+            } else {
+                SendCmd "map box end $x $y"
             }
         }
@@ -2280,4 +2383,22 @@
             Camera reset
         }
+        "viewpoint" {
+            if {[llength $args] < 1} {
+                error "wrong # args to camera viewpoint"
+            }
+            set vpopt [lindex $args 0]
+            switch -- $vpopt {
+                "go" {
+                    if {[llength $args] < 3} {
+                        error "wrong # of args to camera viewpoint go"
+                    }
+                    foreach {dataobj viewpoint} [lrange $args 1 end] break
+                    GoToViewpoint $dataobj $viewpoint
+                }
+                default {
+                    error "Unknown camera viewpoint option \"$vpopt\""
+                }
+            }
+        }
         "zoom" {
             if {[llength $args] < 1} {
@@ -2415,5 +2536,5 @@
 }
 
-itcl::body Rappture::MapViewer::GoToViewpoint { dataobj viewpoint } {
+itcl::body Rappture::MapViewer::GoToViewpoint { dataobj viewpoint {duration 2.0}} {
     array set view [subst {
         x 0
@@ -2436,5 +2557,4 @@
         set _view(pitch) -90
     }
-    set duration 2.0
     SendCmd [list camera set $_view(x) $_view(y) $_view(z) $_view(heading) $_view(pitch) $_view(distance) $duration $_view(srs) $_view(verticalDatum)]
 }
@@ -2694,20 +2814,52 @@
                 }
             }
-            set format ""
-            set wfsType ""
             SendStylesheetFiles $info(stylesheet)
-            if { [info exists info(ogr.connection)] } {
-                set cmd [list map layer add $tag feature db $format $info(ogr.layer) $info(ogr.connection) $info(cache) $info(stylesheet) $script $selectors]
-                if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
-                    lappend cmd $style(-minrange) $style(-maxrange)
-                }
-            } else {
-                set cmd [list map layer add $tag feature $info(driver) $format $wfsType $info(ogr.url) $info(cache) $info(stylesheet) $script $selectors]
-                if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
-                    lappend cmd $style(-minrange) $style(-maxrange)
-                }
-                SendFiles $info(ogr.url)
+            set ssSize [string length $info(stylesheet)]
+            set scriptSize [string length $script]
+            set selectorsSize [string length $selectors]
+            switch -- $info(driver) {
+                "ogr" {
+                    if { [info exists info(ogr.connection)] } {
+                        set cmd [list map layer add $tag feature db {} $info(ogr.layer) $info(ogr.connection) $info(cache) $ssSize $scriptSize $selectorsSize]
+                        if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
+                            lappend cmd $style(-minrange) $style(-maxrange)
+                        }
+                    } else {
+                        set cmd [list map layer add $tag feature $info(driver) {} {} $info(ogr.url) $info(cache) $ssSize $scriptSize $selectorsSize]
+                        if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
+                            lappend cmd $style(-minrange) $style(-maxrange)
+                        }
+                        SendFiles $info(ogr.url)
+                    }
+                }
+                "tfs" {
+                    set format "json"
+                    if {[info exists info(tfs.format)]} {
+                        set format $info(tfs.format)
+                    }
+                    set cmd [list map layer add $tag feature $info(driver) $format {} $info(tfs.url) $info(cache) $ssSize $scriptSize $selectorsSize]
+                    if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
+                        lappend cmd $style(-minrange) $style(-maxrange)
+                    }
+                }
+                "wfs" {
+                    set format "json"
+                    if {[info exists info(wfs.format)]} {
+                        set format $info(wfs.format)
+                    }
+                    set wfsType ""
+                    if {[info exists info(wfs.typename)]} {
+                        set wfsType $info(wfs.typename)
+                    }
+                    set cmd [list map layer add $tag feature $info(driver) $format $wfsType $info(wfs.url) $info(cache) $ssSize $scriptSize $selectorsSize]
+                    if {[info exists style(-minrange)] && [info exists style(-maxrange)]} {
+                        lappend cmd $style(-minrange) $style(-maxrange)
+                    }
+                }
             }
             SendCmd $cmd
+            if { $ssSize > 0 }        { SendData $info(stylesheet) }
+            if { $scriptSize > 0 }    { SendData $script }
+            if { $selectorsSize > 0 } { SendData $selectors }
             SendCmd "map layer opacity $style(-opacity) $tag"
         }
@@ -3142,2 +3294,22 @@
     }
 }
+
+# ----------------------------------------------------------------------
+# OPTION: -map
+# ----------------------------------------------------------------------
+itcl::configbody Rappture::MapViewer::map {
+    if {$itk_option(-map) != "" } {
+        if {[catch {$itk_option(-map) isa Rappture::Map} valid] != 0 || !$valid} {
+            error "bad value \"$itk_option(-map)\": should be Rappture::Map object"
+        }
+        $this clear
+        $this add $itk_option(-map)
+        $this scale $itk_option(-map)
+    } else {
+        $this clear
+    }
+
+    if { [isconnected] } {
+        $_dispatcher event -idle !rebuild
+    }
+}
Index: /branches/multichoice/gui/scripts/mesh.tcl
===================================================================
--- /branches/multichoice/gui/scripts/mesh.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/mesh.tcl	(revision 6371)
@@ -211,4 +211,5 @@
         set result [ReadUnstructuredGrid $path]
     } elseif {[$_mesh element "node"] != "" && [$_mesh element "element"] != ""} {
+        puts stderr "WARNING: <node>/<element> mesh is deprecated.  Please use an unstructured mesh instead."
         set result [ReadNodesElements $path]
     }
@@ -1438,5 +1439,5 @@
     array set node2celltype {
         3 5
-        4 10
+        4 9
         8 12
         6 13
@@ -1452,13 +1453,25 @@
         set numNodes [llength $nodeList]
         if { ![info exists node2celltype($numNodes)] } {
-            puts stderr "WARNING: bad nodes/elements mesh \$path\": unknown number of indices \"$_numNodes\": should be 3, 4, 5, 6, or 8"
+            puts stderr "WARNING: bad node/element mesh \$path\": unknown number of nodes \"$numNodes\": should be 3, 4, 5, 6, or 8"
             return 0
         }
         set celltype $node2celltype($numNodes)
+        if { $_dim == 3 && $numNodes == 4 } {
+            # If mesh is 3D, assume a tetrahedron (default is quad)
+            # XXX: Does prophet output tets, and if so what is the node order?
+            set celltype 10
+        }
         append celltypes "$celltype\n"
-        if { $celltype == 12 } {
-            # Formerly used voxels instead of hexahedrons. We're converting
-            # it here to be backward compatible and still fault-tolerant of
-            # non-axis aligned cells.
+        if { $celltype == 9 } {
+            # Fix the node order for quad cells
+            # (this converts from PROPHET convention to VTK convention)
+            set newList {}
+            foreach i { 0 1 3 2 } {
+                lappend newList [lindex $nodeList $i]
+            }
+            set nodeList $newList
+        } elseif { $celltype == 12 } {
+            # Fix the node order for hexahedron cells
+            # (this converts from PROPHET convention to VTK convention)
             set newList {}
             foreach i { 0 1 3 2 4 5 7 6 } {
Index: /branches/multichoice/gui/scripts/nanovisviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/nanovisviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/nanovisviewer.tcl	(revision 6371)
@@ -119,21 +119,21 @@
 
     private variable _arcball ""
-    private variable _dlist ""         ;# list of data objects
-    private variable _obj2ovride       ;# maps dataobj => style override
-    private variable _datasets         ;# contains all the dataobj-component
-                                       ;# to volumes in the server
-
-    private variable _reset 1          ;# Connection to server has been reset.
-    private variable _click            ;# Info used for rotate operations.
-    private variable _limits           ;# Autoscale min/max for all axes
-    private variable _view             ;# View params for 3D view
+    private variable _dlist "";         # list of data objects
+    private variable _obj2ovride;       # maps dataobj => style override
+    private variable _datasets;         # maps dataobj-component
+                                        # to volumes in the server
+
+    private variable _reset 1;          # Connection to server has been reset.
+    private variable _click;            # Info used for rotate operations.
+    private variable _limits;           # Autoscale min/max for all axes
+    private variable _view;             # View params for 3D view
     private variable _parsedFunction
     private variable _transferFunctionEditors
     private variable _settings
-    private variable _first ""         ;# This is the topmost volume.
-    private variable _current ""       ;# Currently selected component
-    private variable _volcomponents    ;# Maps component name to list of
-                                       ;# dataobj-component tags
-    private variable _componentsList   ;# List of components found
+    private variable _first "";         # This is the topmost volume.
+    private variable _current "";       # Currently selected component
+    private variable _volcomponents;    # Maps component name to list of
+                                        # dataobj-component tags
+    private variable _componentsList;   # List of components found
     private variable _cname2transferFunction
     private variable _cname2defaultcolormap
@@ -143,5 +143,5 @@
     private variable _resizeLegendPending 0
 
-    private common _downloadPopup      ;# download options from popup
+    private common _downloadPopup;      # download options from popup
     private common _hardcopy
 }
@@ -462,5 +462,5 @@
     set op [lindex $args 0]
     switch -- $op {
-        -objects {
+        "-objects" {
             # put the dataobj list in order according to -raise options
             set dlist $_dlist
@@ -477,5 +477,5 @@
             return $dlist
         }
-        -image {
+        "-image" {
             if {[llength $args] != 2} {
                 error "wrong # args: should be \"get -image view|legend\""
@@ -871,5 +871,7 @@
         DoResize
     }
-
+    if { $_reset } {
+        InitSettings -background -axesvisible -gridvisible
+    }
     set _first ""
     SendCmd "volume state 0"
@@ -926,6 +928,5 @@
 
     if { $_reset } {
-        InitSettings -axesvisible -gridvisible \
-            -opacity -light2side -isosurfaceshading \
+        InitSettings -opacity -light2side -isosurfaceshading \
             -ambient -diffuse -specularlevel -specularexponent \
             -current
@@ -1549,5 +1550,5 @@
         } else {
             # $n : absolute value, compute relative
-            lappend list  [expr {(double($value)-$min)/($max-$min)]}
+            lappend list [expr {(double($value)-$min)/($max-$min)}]
         }
     }
@@ -2029,5 +2030,5 @@
     radiobutton $inner.image_button -text "Image File" \
         -variable [itcl::scope _downloadPopup(format)] \
-        -font "Arial 9 " \
+        -font "Arial 9" \
         -value image
     Rappture::Tooltip::for $inner.image_button \
Index: /branches/multichoice/gui/scripts/probdisteditor.tcl
===================================================================
--- /branches/multichoice/gui/scripts/probdisteditor.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/probdisteditor.tcl	(revision 6371)
@@ -19,10 +19,12 @@
 option add *ProbDistEditor*Entry.width 10 widgetDefault
 
-    itcl::class Rappture::ProbDistEditor {
+itcl::class Rappture::ProbDistEditor {
     inherit itk::Widget
 
     itk_option define -fillcolor fillColor FillColor ""
 
-    constructor {args} { # defined below }
+    constructor {args} {
+        # defined below
+    }
     public method value {{newval ""}}
     public method mode {{newval ""}}
@@ -33,11 +35,11 @@
     protected method _apply {op {widget ""}}
 
-    protected variable _dispatcher ""   ;# dispatcher for !events
-    protected variable _mode ""         ;# type of distribution function
-    protected variable _value           ;# data values for mode-detail
-    protected variable _uvalue          ;# data values for mode-detail with units
-    protected variable _umin             ;# minimum allowed value for tool with units
-    protected variable _umax             ;# maximum allowed value for tool with units
-    protected variable _units           ;# units for min and max
+    protected variable _dispatcher "";  # dispatcher for !events
+    protected variable _mode "";        # type of distribution function
+    protected variable _value;          # data values for mode-detail
+    protected variable _uvalue;         # data values for mode-detail with units
+    protected variable _umin;           # minimum allowed value for tool with units
+    protected variable _umax;           # maximum allowed value for tool with units
+    protected variable _units;          # units for min and max
 }
 
Index: /branches/multichoice/gui/scripts/responseviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/responseviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/responseviewer.tcl	(revision 6371)
@@ -147,14 +147,14 @@
 
 itcl::body Rappture::ResponseViewer::_plot_response {var1 var2} {
-    #puts "plotting $var1 vs $var2"
-
-    set fname response_result.xml
-
-    set rs $_response
-    if {[catch {exec puq get_response $fname $rs $var1 $var2 $_label} res]} {
+    #puts stderr "plotting $var1 vs $var2"
+    global rapptureInfo 
+    set fname [file join $rapptureInfo(cwd) "response_result.xml"]
+    if { [catch {
+        exec puq.sh get_response $fname $_response $var1 $var2 $_label
+    } res] != 0 } {
         set fp [open "response.err" r]
         set rdata [read $fp]
         close $fp
-        puts "Surrogate Model failed: $res\n$rdata"
+        puts stderr "Surrogate Model failed: $res\n$rdata"
         error "Sampling of Surrogate Model failed: $res\n$rdata"
         # FIXME: Maybe put in text box instead of error()?
@@ -163,5 +163,5 @@
 
     set xmlobj [Rappture::library $fname]
-    #puts "xmlobj=$xmlobj"
+    #puts stderr "xmlobj=$xmlobj"
     set w $itk_component(frame).field
 
Index: /branches/multichoice/gui/scripts/transferfunctioneditor.tcl
===================================================================
--- /branches/multichoice/gui/scripts/transferfunctioneditor.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/transferfunctioneditor.tcl	(revision 6371)
@@ -42,6 +42,6 @@
     private method GetScreenPosition { name }
     private method LeaveTick { name }
-    private method SetRelativeValue  { name x }
-    private method GetRelativeValue  { name }
+    private method SetRelativeValue { name x }
+    private method GetRelativeValue { name }
     private method RemoveDuplicateMarkers {name x y}
     private method SetScreenPosition { name }
@@ -225,9 +225,14 @@
 }
 
-itcl::body Rappture::TransferFunctionEditor::GetRelativeValue  { name } {
+itcl::body Rappture::TransferFunctionEditor::GetRelativeValue { name } {
     return $_values($name)
 }
 
-itcl::body Rappture::TransferFunctionEditor::SetRelativeValue  { name value } {
+itcl::body Rappture::TransferFunctionEditor::SetRelativeValue { name value } {
+    if {$value < 0.0} {
+        set value 0.0
+    } elseif {$value > 1.0} {
+        set value 1.0
+    }
     set _values($name) $value
     set x [GetScreenPosition $name]
Index: /branches/multichoice/gui/scripts/visviewer.tcl
===================================================================
--- /branches/multichoice/gui/scripts/visviewer.tcl	(revision 6370)
+++ /branches/multichoice/gui/scripts/visviewer.tcl	(revision 6371)
@@ -20,46 +20,4 @@
     itk_option define -receivecommand receiveCommand ReceiveCommand ""
 
-    private common _servers         ;# array of visualization server lists
-    set _servers(geovis)  "localhost:2015"
-    set _servers(nanovis) "localhost:2000"
-    set _servers(pymol)   "localhost:2020"
-    set _servers(vmdmds)  "localhost:2018"
-    set _servers(vtkvis)  "localhost:2010"
-
-    private common _done            ;   # Used to indicate status of send.
-    private variable _buffer        ;   # buffer for incoming/outgoing commands
-    private variable _outbuf       ;    # buffer for outgoing commands
-    private variable _blockOnWrite 0;   # Should writes to socket block?
-    private variable _initialized
-    private variable _isOpen 0
-    private variable _afterId -1
-    private variable _icon 0
-    private variable _trace 0        ;    # Protocol tracing for console
-    private variable _logging 0      ;    # Command logging to file
-    # Number of milliseconds to wait before idle timeout.  If greater than 0,
-    # automatically disconnect from the visualization server when idle timeout
-    # is reached.
-    private variable _idleTimeout 43200000; # 12 hours
-    #private variable _idleTimeout 5000;    # 5 seconds
-    #private variable _idleTimeout 0;       # No timeout
-
-    protected variable _debug 0
-    protected variable _serverType "???";# Type of server.
-    protected variable _sid ""      ;   # socket connection to server
-    protected variable _maxConnects 100
-    protected variable _buffering 0
-    protected variable _cmdSeq 0     ;    # Command sequence number
-    protected variable _dispatcher "";  # dispatcher for !events
-    protected variable _hosts ""    ;   # list of hosts for server
-    protected variable _parser ""   ;   # interpreter for incoming commands
-    protected variable _image
-    protected variable _hostname
-    protected variable _numConnectTries 0
-    protected variable _debugConsole 0
-    protected variable _reportClientInfo 1
-    # Number of milliscends to wait for server reply before displaying wait
-    # dialog.  If set to 0, dialog is never displayed.
-    protected variable _waitTimeout 0
-
     constructor { args } {
         # defined below
@@ -68,16 +26,33 @@
         # defined below
     }
-    # Used internally only.
-    private method BuildConsole {}
-    private method DebugConsole {}
-    private method HideConsole {}
-    private method ReceiveHelper {}
-    private method SendDebugCommand {}
-    private method SendHelper {}
-    private method ServerDown {}
-    private method Shuffle { servers }
-    private method TraceComm { channel {data {}} }
-    private method WaitDialog { state }
-    private method Waiting { option widget }
+    public proc GetServerList { type } {
+        return $_servers($type)
+    }
+    public proc SetServerList { type namelist } {
+        # Convert the comma separated list into a Tcl list.  OGRE also adds
+        # a trailing comma that we want to ignore.
+        regsub -all "," $namelist " " namelist
+        CheckNameList $namelist
+        set _servers($type) $namelist
+    }
+    public proc RemoveServerFromList { type server } {
+        if { ![info exists _servers($type)] } {
+            error "unknown server type \"$type\""
+        }
+        set i [lsearch $_servers($type) $server]
+        if { $i < 0 } {
+            return
+        }
+        set _servers($type) [lreplace $_servers($type) $i $i]
+    }
+    public proc SetPymolServerList { namelist } {
+        SetServerList "pymol" $namelist
+    }
+    public proc SetNanovisServerList { namelist } {
+        SetServerList "nanovis" $namelist
+    }
+    public proc SetVtkServerList { namelist } {
+        SetServerList "vtk" $namelist
+    }
 
     protected method CheckConnection {}
@@ -117,4 +92,34 @@
     protected method ToggleConsole {}
 
+    protected variable _debug 0
+    protected variable _serverType "???";# Type of server.
+    protected variable _sid "";         # socket connection to server
+    protected variable _maxConnects 100
+    protected variable _buffering 0
+    protected variable _cmdSeq 0;       # Command sequence number
+    protected variable _dispatcher "";  # dispatcher for !events
+    protected variable _hosts "";       # list of hosts for server
+    protected variable _parser "";      # interpreter for incoming commands
+    protected variable _image
+    protected variable _hostname
+    protected variable _numConnectTries 0
+    protected variable _debugConsole 0
+    protected variable _reportClientInfo 1
+    # Number of milliscends to wait for server reply before displaying wait
+    # dialog.  If set to 0, dialog is never displayed.
+    protected variable _waitTimeout 0
+
+    private method BuildConsole {}
+    private method DebugConsole {}
+    private method HideConsole {}
+    private method ReceiveHelper {}
+    private method SendDebugCommand {}
+    private method SendHelper {}
+    private method ServerDown {}
+    private method Shuffle { servers }
+    private method TraceComm { channel {data {}} }
+    private method WaitDialog { state }
+    private method Waiting { option widget }
+
     private proc CheckNameList { namelist }  {
         foreach host $namelist {
@@ -125,33 +130,28 @@
         }
     }
-    public proc GetServerList { type } {
-        return $_servers($type)
-    }
-    public proc SetServerList { type namelist } {
-        # Convert the comma separated list into a Tcl list.  OGRE also adds
-        # a trailing comma that we want to ignore.
-        regsub -all "," $namelist " " namelist
-        CheckNameList $namelist
-        set _servers($type) $namelist
-    }
-    public proc RemoveServerFromList { type server } {
-        if { ![info exists _servers($type)] } {
-            error "unknown server type \"$type\""
-        }
-        set i [lsearch $_servers($type) $server]
-        if { $i < 0 } {
-            return
-        }
-        set _servers($type) [lreplace $_servers($type) $i $i]
-    }
-    public proc SetPymolServerList { namelist } {
-        SetServerList "pymol" $namelist
-    }
-    public proc SetNanovisServerList { namelist } {
-        SetServerList "nanovis" $namelist
-    }
-    public proc SetVtkServerList { namelist } {
-        SetServerList "vtk" $namelist
-    }
+
+    private variable _buffer;           # buffer for incoming/outgoing commands
+    private variable _outbuf;           # buffer for outgoing commands
+    private variable _blockOnWrite 0;   # Should writes to socket block?
+    private variable _initialized
+    private variable _isOpen 0
+    private variable _afterId -1
+    private variable _icon 0
+    private variable _trace 0;          # Protocol tracing for console
+    private variable _logging 0;        # Command logging to file
+    # Number of milliseconds to wait before idle timeout.  If greater than 0,
+    # automatically disconnect from the visualization server when idle timeout
+    # is reached.
+    private variable _idleTimeout 43200000; # 12 hours
+    #private variable _idleTimeout 5000;# 5 seconds
+    #private variable _idleTimeout 0;   # No timeout
+
+    private common _servers;            # array of visualization server lists
+    set _servers(geovis)  "localhost:2015"
+    set _servers(nanovis) "localhost:2000"
+    set _servers(pymol)   "localhost:2020"
+    set _servers(vmdmds)  "localhost:2018"
+    set _servers(vtkvis)  "localhost:2010"
+    private common _done;               # Used to indicate status of send.
 }
 
@@ -864,5 +864,5 @@
                 -xscrollmode auto -yscrollmode auto
             text $inner.scrl.text \
-                -font "Arial 9 " -background white -relief sunken -bd 1 \
+                -font "Arial 9" -background white -relief sunken -bd 1 \
                 -height 5 -wrap word -width 60
             $inner.scrl contents $inner.scrl.text
